/* PrinterManager.c generated by valac 0.56.17, the Vala compiler
 * generated from PrinterManager.vala, do not modify */

/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "cups/cups.h"
#include <gio/gio.h>
#include "cups/ipp.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PRINTERS_PRINTER_MANAGER_0_PROPERTY,
	PRINTERS_PRINTER_MANAGER_NUM_PROPERTIES
};
static GParamSpec* printers_printer_manager_properties[PRINTERS_PRINTER_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _ippDelete0(var) ((var == NULL) ? NULL : (var = (ippDelete (var), NULL)))
typedef struct _PrintersPrinterManagerNewSubscriptionData PrintersPrinterManagerNewSubscriptionData;
enum  {
	PRINTERS_PRINTER_MANAGER_PRINTER_ADDED_SIGNAL,
	PRINTERS_PRINTER_MANAGER_NUM_SIGNALS
};
static guint printers_printer_manager_signals[PRINTERS_PRINTER_MANAGER_NUM_SIGNALS] = {0};

struct _PrintersPrinterManagerPrivate {
	gint subscription_id;
	GeeLinkedList* printers;
};

struct _PrintersPrinterManagerNewSubscriptionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PrintersPrinterManager* self;
	ipp_t* request;
	ipp_t* _tmp0_;
	ipp_t* _tmp1_;
	ipp_t* _tmp2_;
	ipp_t* _tmp3_;
	ipp_t* _tmp4_;
	ipp_t* _tmp5_;
	ipp_t* _tmp6_;
	ipp_t* _tmp7_;
	const gchar* _tmp8_;
	ipp_t* _tmp9_;
	http_t* _tmp10_;
	gboolean _tmp11_;
	ipp_t* _tmp12_;
	ipp_t* _tmp13_;
	ipp_attribute_t* attr;
	ipp_t* _tmp14_;
	ipp_attribute_t* _tmp15_;
	ipp_attribute_t* _tmp16_;
	ipp_attribute_t* _tmp17_;
};

static gint PrintersPrinterManager_private_offset;
static gpointer printers_printer_manager_parent_class = NULL;
static PrintersPrinterManager* printers_printer_manager_printer_manager;
static PrintersPrinterManager* printers_printer_manager_printer_manager = NULL;

static PrintersPrinterManager* printers_printer_manager_new (void);
static PrintersPrinterManager* printers_printer_manager_construct (GType object_type);
static void printers_printer_manager_add_printer (PrintersPrinterManager* self,
                                           cups_dest_t* destination);
static void printers_printer_manager_printer_is_added (PrintersPrinterManager* self,
                                                const gchar* text,
                                                const gchar* printer_uri,
                                                const gchar* name,
                                                guint32 state,
                                                const gchar* state_reasons,
                                                gboolean is_accepting_jobs);
static void _printers_printer_manager_printer_is_added_cups_notifier_printer_added (CupsNotifier* _sender,
                                                                             const gchar* text,
                                                                             const gchar* printer_uri,
                                                                             const gchar* name,
                                                                             guint32 state,
                                                                             const gchar* state_reasons,
                                                                             gboolean is_accepting_jobs,
                                                                             gpointer self);
static void printers_printer_manager_printer_is_deleted (PrintersPrinterManager* self,
                                                  const gchar* text,
                                                  const gchar* printer_uri,
                                                  const gchar* name,
                                                  guint32 state,
                                                  const gchar* state_reasons,
                                                  gboolean is_accepting_jobs);
static void _printers_printer_manager_printer_is_deleted_cups_notifier_printer_deleted (CupsNotifier* _sender,
                                                                                 const gchar* text,
                                                                                 const gchar* printer_uri,
                                                                                 const gchar* name,
                                                                                 guint32 state,
                                                                                 const gchar* state_reasons,
                                                                                 gboolean is_accepting_jobs,
                                                                                 gpointer self);
static void printers_printer_manager_printer_state_has_changed (PrintersPrinterManager* self,
                                                         const gchar* text,
                                                         const gchar* printer_uri,
                                                         const gchar* name,
                                                         guint32 state,
                                                         const gchar* state_reasons,
                                                         gboolean is_accepting_jobs);
static void _printers_printer_manager_printer_state_has_changed_cups_notifier_printer_state_changed (CupsNotifier* _sender,
                                                                                              const gchar* text,
                                                                                              const gchar* printer_uri,
                                                                                              const gchar* name,
                                                                                              guint32 state,
                                                                                              const gchar* state_reasons,
                                                                                              gboolean is_accepting_jobs,
                                                                                              gpointer self);
static void printers_printer_manager_printer_is_modified (PrintersPrinterManager* self,
                                                   const gchar* text,
                                                   const gchar* printer_uri,
                                                   const gchar* name,
                                                   guint32 state,
                                                   const gchar* state_reasons,
                                                   gboolean is_accepting_jobs);
static void _printers_printer_manager_printer_is_modified_cups_notifier_printer_modified (CupsNotifier* _sender,
                                                                                   const gchar* text,
                                                                                   const gchar* printer_uri,
                                                                                   const gchar* name,
                                                                                   guint32 state,
                                                                                   const gchar* state_reasons,
                                                                                   gboolean is_accepting_jobs,
                                                                                   gpointer self);
static void printers_printer_manager_new_subscription (PrintersPrinterManager* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void printers_printer_manager_new_subscription_finish (PrintersPrinterManager* self,
                                                       GAsyncResult* _res_);
static gboolean __lambda47_ (PrintersPrinterManager* self);
static gboolean ___lambda47__gsource_func (gpointer self);
static void printers_printer_manager_new_subscription_data_free (gpointer _data);
static gboolean printers_printer_manager_new_subscription_co (PrintersPrinterManagerNewSubscriptionData* _data_);
static void printers_printer_manager_finalize (GObject * obj);
static GType printers_printer_manager_get_type_once (void);

static const gchar* PRINTERS_PRINTER_MANAGER_SUBSCRIPTION_EVENTS[9] = {"printer-added", "printer-deleted", "printer-stopped", "printer-shutdown", "printer-restarted", "printer-state-changed", "job-created", "job-completed", NULL};

static inline gpointer
printers_printer_manager_get_instance_private (PrintersPrinterManager* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersPrinterManager_private_offset);
}

PrintersPrinterManager*
printers_printer_manager_get_default (void)
{
	PrintersPrinterManager* _tmp0_;
	PrintersPrinterManager* _tmp2_;
	PrintersPrinterManager* result;
#line 28 "../src/Objects/PrinterManager.vala"
	_tmp0_ = printers_printer_manager_printer_manager;
#line 28 "../src/Objects/PrinterManager.vala"
	if (_tmp0_ == NULL) {
#line 192 "PrinterManager.c"
		PrintersPrinterManager* _tmp1_;
#line 29 "../src/Objects/PrinterManager.vala"
		_tmp1_ = printers_printer_manager_new ();
#line 29 "../src/Objects/PrinterManager.vala"
		_g_object_unref0 (printers_printer_manager_printer_manager);
#line 29 "../src/Objects/PrinterManager.vala"
		printers_printer_manager_printer_manager = _tmp1_;
#line 200 "PrinterManager.c"
	}
#line 32 "../src/Objects/PrinterManager.vala"
	_tmp2_ = printers_printer_manager_printer_manager;
#line 32 "../src/Objects/PrinterManager.vala"
	result = _tmp2_;
#line 32 "../src/Objects/PrinterManager.vala"
	return result;
#line 208 "PrinterManager.c"
}

static cups_dest_t*
cups_get_destinations (gint* result_length1)
{
	cups_dest_t* temp = NULL;
	gint temp_length1 = 0;
	gint _temp_size_ = 0;
	gint len = 0;
	cups_dest_t* _tmp0_ = NULL;
	gint _tmp1_;
	cups_dest_t* _tmp2_;
	gint _tmp2__length1;
	cups_dest_t* result;
#line 186 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp1_ = cupsGetDests (&_tmp0_);
#line 186 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	temp = _tmp0_;
#line 186 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	temp_length1 = -1;
#line 186 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_temp_size_ = temp_length1;
#line 186 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	len = _tmp1_;
#line 187 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	temp_length1 = len;
#line 188 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp2_ = temp;
#line 188 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	_tmp2__length1 = temp_length1;
#line 188 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	if (result_length1) {
#line 188 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
		*result_length1 = _tmp2__length1;
#line 243 "PrinterManager.c"
	}
#line 188 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	result = _tmp2_;
#line 188 "/builddir/build/BUILD/switchboard-plug-printers-2.2.1/vapi/cups.vapi"
	return result;
#line 249 "PrinterManager.c"
}

static void
_printers_printer_manager_printer_is_added_cups_notifier_printer_added (CupsNotifier* _sender,
                                                                        const gchar* text,
                                                                        const gchar* printer_uri,
                                                                        const gchar* name,
                                                                        guint32 state,
                                                                        const gchar* state_reasons,
                                                                        gboolean is_accepting_jobs,
                                                                        gpointer self)
{
#line 48 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_printer_is_added ((PrintersPrinterManager*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs);
#line 264 "PrinterManager.c"
}

static void
_printers_printer_manager_printer_is_deleted_cups_notifier_printer_deleted (CupsNotifier* _sender,
                                                                            const gchar* text,
                                                                            const gchar* printer_uri,
                                                                            const gchar* name,
                                                                            guint32 state,
                                                                            const gchar* state_reasons,
                                                                            gboolean is_accepting_jobs,
                                                                            gpointer self)
{
#line 49 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_printer_is_deleted ((PrintersPrinterManager*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs);
#line 279 "PrinterManager.c"
}

static void
_printers_printer_manager_printer_state_has_changed_cups_notifier_printer_state_changed (CupsNotifier* _sender,
                                                                                         const gchar* text,
                                                                                         const gchar* printer_uri,
                                                                                         const gchar* name,
                                                                                         guint32 state,
                                                                                         const gchar* state_reasons,
                                                                                         gboolean is_accepting_jobs,
                                                                                         gpointer self)
{
#line 50 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_printer_state_has_changed ((PrintersPrinterManager*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs);
#line 294 "PrinterManager.c"
}

static void
_printers_printer_manager_printer_is_modified_cups_notifier_printer_modified (CupsNotifier* _sender,
                                                                              const gchar* text,
                                                                              const gchar* printer_uri,
                                                                              const gchar* name,
                                                                              guint32 state,
                                                                              const gchar* state_reasons,
                                                                              gboolean is_accepting_jobs,
                                                                              gpointer self)
{
#line 51 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_printer_is_modified ((PrintersPrinterManager*) self, text, printer_uri, name, state, state_reasons, is_accepting_jobs);
#line 309 "PrinterManager.c"
}

static gboolean
__lambda47_ (PrintersPrinterManager* self)
{
	gboolean result;
#line 55 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_new_subscription (self, NULL, NULL);
#line 56 "../src/Objects/PrinterManager.vala"
	result = G_SOURCE_CONTINUE;
#line 56 "../src/Objects/PrinterManager.vala"
	return result;
#line 322 "PrinterManager.c"
}

static gboolean
___lambda47__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda47_ ((PrintersPrinterManager*) self);
#line 54 "../src/Objects/PrinterManager.vala"
	return result;
#line 332 "PrinterManager.c"
}

static PrintersPrinterManager*
printers_printer_manager_construct (GType object_type)
{
	PrintersPrinterManager * self = NULL;
	GeeLinkedList* _tmp0_;
	cups_dest_t* dests = NULL;
	gint _tmp1_ = 0;
	cups_dest_t* _tmp2_;
	gint dests_length1;
	gint _dests_size_;
	cups_dest_t* _tmp3_;
	gint _tmp3__length1;
	CupsNotifier* notifier = NULL;
	CupsNotifier* _tmp5_;
#line 40 "../src/Objects/PrinterManager.vala"
	self = (PrintersPrinterManager*) g_object_new (object_type, NULL);
#line 41 "../src/Objects/PrinterManager.vala"
	_tmp0_ = gee_linked_list_new (PRINTERS_TYPE_PRINTER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 41 "../src/Objects/PrinterManager.vala"
	_g_object_unref0 (self->priv->printers);
#line 41 "../src/Objects/PrinterManager.vala"
	self->priv->printers = _tmp0_;
#line 42 "../src/Objects/PrinterManager.vala"
	_tmp2_ = cups_get_destinations (&_tmp1_);
#line 42 "../src/Objects/PrinterManager.vala"
	dests = _tmp2_;
#line 42 "../src/Objects/PrinterManager.vala"
	dests_length1 = _tmp1_;
#line 42 "../src/Objects/PrinterManager.vala"
	_dests_size_ = dests_length1;
#line 43 "../src/Objects/PrinterManager.vala"
	_tmp3_ = dests;
#line 43 "../src/Objects/PrinterManager.vala"
	_tmp3__length1 = dests_length1;
#line 369 "PrinterManager.c"
	{
		cups_dest_t* dest_collection = NULL;
		gint dest_collection_length1 = 0;
		gint _dest_collection_size_ = 0;
		gint dest_it = 0;
#line 43 "../src/Objects/PrinterManager.vala"
		dest_collection = _tmp3_;
#line 43 "../src/Objects/PrinterManager.vala"
		dest_collection_length1 = _tmp3__length1;
#line 43 "../src/Objects/PrinterManager.vala"
		for (dest_it = 0; dest_it < dest_collection_length1; dest_it = dest_it + 1) {
#line 381 "PrinterManager.c"
			cups_dest_t dest = {0};
#line 43 "../src/Objects/PrinterManager.vala"
			dest = dest_collection[dest_it];
#line 385 "PrinterManager.c"
			{
				cups_dest_t _tmp4_;
#line 44 "../src/Objects/PrinterManager.vala"
				_tmp4_ = dest;
#line 44 "../src/Objects/PrinterManager.vala"
				printers_printer_manager_add_printer (self, &_tmp4_);
#line 392 "PrinterManager.c"
			}
		}
	}
#line 47 "../src/Objects/PrinterManager.vala"
	_tmp5_ = cups_notifier_get_default ();
#line 47 "../src/Objects/PrinterManager.vala"
	notifier = _tmp5_;
#line 48 "../src/Objects/PrinterManager.vala"
	g_signal_connect_object (notifier, "printer-added", (GCallback) _printers_printer_manager_printer_is_added_cups_notifier_printer_added, self, 0);
#line 49 "../src/Objects/PrinterManager.vala"
	g_signal_connect_object (notifier, "printer-deleted", (GCallback) _printers_printer_manager_printer_is_deleted_cups_notifier_printer_deleted, self, 0);
#line 50 "../src/Objects/PrinterManager.vala"
	g_signal_connect_object (notifier, "printer-state-changed", (GCallback) _printers_printer_manager_printer_state_has_changed_cups_notifier_printer_state_changed, self, 0);
#line 51 "../src/Objects/PrinterManager.vala"
	g_signal_connect_object (notifier, "printer-modified", (GCallback) _printers_printer_manager_printer_is_modified_cups_notifier_printer_modified, self, 0);
#line 53 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_new_subscription (self, NULL, NULL);
#line 54 "../src/Objects/PrinterManager.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, PRINTERS_PRINTER_MANAGER_RENEW_INTERVAL, ___lambda47__gsource_func, g_object_ref (self), g_object_unref);
#line 40 "../src/Objects/PrinterManager.vala"
	return self;
#line 414 "PrinterManager.c"
}

static PrintersPrinterManager*
printers_printer_manager_new (void)
{
#line 40 "../src/Objects/PrinterManager.vala"
	return printers_printer_manager_construct (PRINTERS_TYPE_PRINTER_MANAGER);
#line 422 "PrinterManager.c"
}

GeeLinkedList*
printers_printer_manager_get_printers (PrintersPrinterManager* self)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* result;
#line 60 "../src/Objects/PrinterManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/Objects/PrinterManager.vala"
	_tmp0_ = self->priv->printers;
#line 61 "../src/Objects/PrinterManager.vala"
	result = _tmp0_;
#line 61 "../src/Objects/PrinterManager.vala"
	return result;
#line 438 "PrinterManager.c"
}

static void
printers_printer_manager_printer_is_added (PrintersPrinterManager* self,
                                           const gchar* text,
                                           const gchar* printer_uri,
                                           const gchar* name,
                                           guint32 state,
                                           const gchar* state_reasons,
                                           gboolean is_accepting_jobs)
{
	cups_dest_t* destinations = NULL;
	gint _tmp0_ = 0;
	cups_dest_t* _tmp1_;
	gint destinations_length1;
	gint _destinations_size_;
	cups_dest_t* _tmp2_;
	gint _tmp2__length1;
#line 64 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (text != NULL);
#line 64 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (printer_uri != NULL);
#line 64 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (name != NULL);
#line 64 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (state_reasons != NULL);
#line 65 "../src/Objects/PrinterManager.vala"
	_tmp1_ = cups_get_destinations (&_tmp0_);
#line 65 "../src/Objects/PrinterManager.vala"
	destinations = _tmp1_;
#line 65 "../src/Objects/PrinterManager.vala"
	destinations_length1 = _tmp0_;
#line 65 "../src/Objects/PrinterManager.vala"
	_destinations_size_ = destinations_length1;
#line 66 "../src/Objects/PrinterManager.vala"
	_tmp2_ = destinations;
#line 66 "../src/Objects/PrinterManager.vala"
	_tmp2__length1 = destinations_length1;
#line 479 "PrinterManager.c"
	{
		cups_dest_t* dest_collection = NULL;
		gint dest_collection_length1 = 0;
		gint _dest_collection_size_ = 0;
		gint dest_it = 0;
#line 66 "../src/Objects/PrinterManager.vala"
		dest_collection = _tmp2_;
#line 66 "../src/Objects/PrinterManager.vala"
		dest_collection_length1 = _tmp2__length1;
#line 66 "../src/Objects/PrinterManager.vala"
		for (dest_it = 0; dest_it < dest_collection_length1; dest_it = dest_it + 1) {
#line 491 "PrinterManager.c"
			cups_dest_t dest = {0};
#line 66 "../src/Objects/PrinterManager.vala"
			dest = dest_collection[dest_it];
#line 495 "PrinterManager.c"
			{
				cups_dest_t _tmp3_;
				const gchar* _tmp4_;
#line 67 "../src/Objects/PrinterManager.vala"
				_tmp3_ = dest;
#line 67 "../src/Objects/PrinterManager.vala"
				_tmp4_ = _tmp3_.name;
#line 67 "../src/Objects/PrinterManager.vala"
				if (g_strcmp0 (_tmp4_, name) == 0) {
#line 505 "PrinterManager.c"
					cups_dest_t _tmp5_;
#line 68 "../src/Objects/PrinterManager.vala"
					_tmp5_ = dest;
#line 68 "../src/Objects/PrinterManager.vala"
					printers_printer_manager_add_printer (self, &_tmp5_);
#line 69 "../src/Objects/PrinterManager.vala"
					break;
#line 513 "PrinterManager.c"
				}
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 78 "../src/Objects/PrinterManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 525 "PrinterManager.c"
}

static void
printers_printer_manager_printer_is_modified (PrintersPrinterManager* self,
                                              const gchar* text,
                                              const gchar* printer_uri,
                                              const gchar* name,
                                              guint32 state,
                                              const gchar* state_reasons,
                                              gboolean is_accepting_jobs)
{
	PrintersPrinter* found_printer = NULL;
	PrintersPrinter* _tmp13_;
#line 74 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (text != NULL);
#line 74 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (printer_uri != NULL);
#line 74 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (name != NULL);
#line 74 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (state_reasons != NULL);
#line 75 "../src/Objects/PrinterManager.vala"
	found_printer = NULL;
#line 551 "PrinterManager.c"
	{
		GeeLinkedList* _printer_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _printer_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _printer_index = 0;
#line 76 "../src/Objects/PrinterManager.vala"
		_tmp0_ = self->priv->printers;
#line 76 "../src/Objects/PrinterManager.vala"
		_printer_list = _tmp0_;
#line 76 "../src/Objects/PrinterManager.vala"
		_tmp1_ = _printer_list;
#line 76 "../src/Objects/PrinterManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 76 "../src/Objects/PrinterManager.vala"
		_tmp3_ = _tmp2_;
#line 76 "../src/Objects/PrinterManager.vala"
		_printer_size = _tmp3_;
#line 76 "../src/Objects/PrinterManager.vala"
		_printer_index = -1;
#line 76 "../src/Objects/PrinterManager.vala"
		while (TRUE) {
#line 576 "PrinterManager.c"
			gint _tmp4_;
			gint _tmp5_;
			PrintersPrinter* printer = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			PrintersPrinter* _tmp8_;
			cups_dest_t _tmp9_;
			const gchar* _tmp10_;
#line 76 "../src/Objects/PrinterManager.vala"
			_printer_index = _printer_index + 1;
#line 76 "../src/Objects/PrinterManager.vala"
			_tmp4_ = _printer_index;
#line 76 "../src/Objects/PrinterManager.vala"
			_tmp5_ = _printer_size;
#line 76 "../src/Objects/PrinterManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 76 "../src/Objects/PrinterManager.vala"
				break;
#line 595 "PrinterManager.c"
			}
#line 76 "../src/Objects/PrinterManager.vala"
			_tmp6_ = _printer_list;
#line 76 "../src/Objects/PrinterManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _printer_index);
#line 76 "../src/Objects/PrinterManager.vala"
			printer = (PrintersPrinter*) _tmp7_;
#line 77 "../src/Objects/PrinterManager.vala"
			_tmp8_ = printer;
#line 77 "../src/Objects/PrinterManager.vala"
			_tmp9_ = _tmp8_->dest;
#line 77 "../src/Objects/PrinterManager.vala"
			_tmp10_ = _tmp9_.name;
#line 77 "../src/Objects/PrinterManager.vala"
			if (g_strcmp0 (_tmp10_, name) == 0) {
#line 611 "PrinterManager.c"
				PrintersPrinter* _tmp11_;
				PrintersPrinter* _tmp12_;
#line 78 "../src/Objects/PrinterManager.vala"
				_tmp11_ = printer;
#line 78 "../src/Objects/PrinterManager.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 78 "../src/Objects/PrinterManager.vala"
				_g_object_unref0 (found_printer);
#line 78 "../src/Objects/PrinterManager.vala"
				found_printer = _tmp12_;
#line 79 "../src/Objects/PrinterManager.vala"
				_g_object_unref0 (printer);
#line 79 "../src/Objects/PrinterManager.vala"
				break;
#line 626 "PrinterManager.c"
			}
#line 76 "../src/Objects/PrinterManager.vala"
			_g_object_unref0 (printer);
#line 630 "PrinterManager.c"
		}
	}
#line 83 "../src/Objects/PrinterManager.vala"
	_tmp13_ = found_printer;
#line 83 "../src/Objects/PrinterManager.vala"
	if (_tmp13_ == NULL) {
#line 84 "../src/Objects/PrinterManager.vala"
		printers_printer_manager_printer_is_added (self, text, printer_uri, name, state, state_reasons, is_accepting_jobs);
#line 639 "PrinterManager.c"
	}
#line 74 "../src/Objects/PrinterManager.vala"
	_g_object_unref0 (found_printer);
#line 643 "PrinterManager.c"
}

static void
printers_printer_manager_printer_is_deleted (PrintersPrinterManager* self,
                                             const gchar* text,
                                             const gchar* printer_uri,
                                             const gchar* name,
                                             guint32 state,
                                             const gchar* state_reasons,
                                             gboolean is_accepting_jobs)
{
	PrintersPrinter* found_printer = NULL;
	PrintersPrinter* _tmp13_;
#line 88 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (text != NULL);
#line 88 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (printer_uri != NULL);
#line 88 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (name != NULL);
#line 88 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (state_reasons != NULL);
#line 89 "../src/Objects/PrinterManager.vala"
	found_printer = NULL;
#line 669 "PrinterManager.c"
	{
		GeeLinkedList* _printer_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _printer_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _printer_index = 0;
#line 90 "../src/Objects/PrinterManager.vala"
		_tmp0_ = self->priv->printers;
#line 90 "../src/Objects/PrinterManager.vala"
		_printer_list = _tmp0_;
#line 90 "../src/Objects/PrinterManager.vala"
		_tmp1_ = _printer_list;
#line 90 "../src/Objects/PrinterManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 90 "../src/Objects/PrinterManager.vala"
		_tmp3_ = _tmp2_;
#line 90 "../src/Objects/PrinterManager.vala"
		_printer_size = _tmp3_;
#line 90 "../src/Objects/PrinterManager.vala"
		_printer_index = -1;
#line 90 "../src/Objects/PrinterManager.vala"
		while (TRUE) {
#line 694 "PrinterManager.c"
			gint _tmp4_;
			gint _tmp5_;
			PrintersPrinter* printer = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			PrintersPrinter* _tmp8_;
			cups_dest_t _tmp9_;
			const gchar* _tmp10_;
#line 90 "../src/Objects/PrinterManager.vala"
			_printer_index = _printer_index + 1;
#line 90 "../src/Objects/PrinterManager.vala"
			_tmp4_ = _printer_index;
#line 90 "../src/Objects/PrinterManager.vala"
			_tmp5_ = _printer_size;
#line 90 "../src/Objects/PrinterManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 90 "../src/Objects/PrinterManager.vala"
				break;
#line 713 "PrinterManager.c"
			}
#line 90 "../src/Objects/PrinterManager.vala"
			_tmp6_ = _printer_list;
#line 90 "../src/Objects/PrinterManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _printer_index);
#line 90 "../src/Objects/PrinterManager.vala"
			printer = (PrintersPrinter*) _tmp7_;
#line 91 "../src/Objects/PrinterManager.vala"
			_tmp8_ = printer;
#line 91 "../src/Objects/PrinterManager.vala"
			_tmp9_ = _tmp8_->dest;
#line 91 "../src/Objects/PrinterManager.vala"
			_tmp10_ = _tmp9_.name;
#line 91 "../src/Objects/PrinterManager.vala"
			if (g_strcmp0 (_tmp10_, name) == 0) {
#line 729 "PrinterManager.c"
				PrintersPrinter* _tmp11_;
				PrintersPrinter* _tmp12_;
#line 92 "../src/Objects/PrinterManager.vala"
				_tmp11_ = printer;
#line 92 "../src/Objects/PrinterManager.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 92 "../src/Objects/PrinterManager.vala"
				_g_object_unref0 (found_printer);
#line 92 "../src/Objects/PrinterManager.vala"
				found_printer = _tmp12_;
#line 93 "../src/Objects/PrinterManager.vala"
				_g_object_unref0 (printer);
#line 93 "../src/Objects/PrinterManager.vala"
				break;
#line 744 "PrinterManager.c"
			}
#line 90 "../src/Objects/PrinterManager.vala"
			_g_object_unref0 (printer);
#line 748 "PrinterManager.c"
		}
	}
#line 97 "../src/Objects/PrinterManager.vala"
	_tmp13_ = found_printer;
#line 97 "../src/Objects/PrinterManager.vala"
	if (_tmp13_ != NULL) {
#line 755 "PrinterManager.c"
		GeeLinkedList* _tmp14_;
		PrintersPrinter* _tmp15_;
		PrintersPrinter* _tmp16_;
#line 98 "../src/Objects/PrinterManager.vala"
		_tmp14_ = self->priv->printers;
#line 98 "../src/Objects/PrinterManager.vala"
		_tmp15_ = found_printer;
#line 98 "../src/Objects/PrinterManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 99 "../src/Objects/PrinterManager.vala"
		_tmp16_ = found_printer;
#line 99 "../src/Objects/PrinterManager.vala"
		g_signal_emit_by_name (_tmp16_, "deleted");
#line 769 "PrinterManager.c"
	}
#line 88 "../src/Objects/PrinterManager.vala"
	_g_object_unref0 (found_printer);
#line 773 "PrinterManager.c"
}

static void
printers_printer_manager_printer_state_has_changed (PrintersPrinterManager* self,
                                                    const gchar* text,
                                                    const gchar* printer_uri,
                                                    const gchar* name,
                                                    guint32 state,
                                                    const gchar* state_reasons,
                                                    gboolean is_accepting_jobs)
{
#line 103 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (text != NULL);
#line 103 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (printer_uri != NULL);
#line 103 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (name != NULL);
#line 103 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (state_reasons != NULL);
#line 795 "PrinterManager.c"
	{
		GeeLinkedList* _printer_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _printer_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _printer_index = 0;
#line 104 "../src/Objects/PrinterManager.vala"
		_tmp0_ = self->priv->printers;
#line 104 "../src/Objects/PrinterManager.vala"
		_printer_list = _tmp0_;
#line 104 "../src/Objects/PrinterManager.vala"
		_tmp1_ = _printer_list;
#line 104 "../src/Objects/PrinterManager.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 104 "../src/Objects/PrinterManager.vala"
		_tmp3_ = _tmp2_;
#line 104 "../src/Objects/PrinterManager.vala"
		_printer_size = _tmp3_;
#line 104 "../src/Objects/PrinterManager.vala"
		_printer_index = -1;
#line 104 "../src/Objects/PrinterManager.vala"
		while (TRUE) {
#line 820 "PrinterManager.c"
			gint _tmp4_;
			gint _tmp5_;
			PrintersPrinter* printer = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			PrintersPrinter* _tmp8_;
			cups_dest_t _tmp9_;
			const gchar* _tmp10_;
#line 104 "../src/Objects/PrinterManager.vala"
			_printer_index = _printer_index + 1;
#line 104 "../src/Objects/PrinterManager.vala"
			_tmp4_ = _printer_index;
#line 104 "../src/Objects/PrinterManager.vala"
			_tmp5_ = _printer_size;
#line 104 "../src/Objects/PrinterManager.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 104 "../src/Objects/PrinterManager.vala"
				break;
#line 839 "PrinterManager.c"
			}
#line 104 "../src/Objects/PrinterManager.vala"
			_tmp6_ = _printer_list;
#line 104 "../src/Objects/PrinterManager.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _printer_index);
#line 104 "../src/Objects/PrinterManager.vala"
			printer = (PrintersPrinter*) _tmp7_;
#line 105 "../src/Objects/PrinterManager.vala"
			_tmp8_ = printer;
#line 105 "../src/Objects/PrinterManager.vala"
			_tmp9_ = _tmp8_->dest;
#line 105 "../src/Objects/PrinterManager.vala"
			_tmp10_ = _tmp9_.name;
#line 105 "../src/Objects/PrinterManager.vala"
			if (g_strcmp0 (_tmp10_, name) == 0) {
#line 855 "PrinterManager.c"
				PrintersPrinter* _tmp11_;
				PrintersPrinter* _tmp12_;
				PrintersPrinter* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				PrintersPrinter* _tmp16_;
				PrintersPrinter* _tmp17_;
#line 106 "../src/Objects/PrinterManager.vala"
				_tmp11_ = printer;
#line 106 "../src/Objects/PrinterManager.vala"
				printers_printer_set_state_reasons_raw (_tmp11_, state_reasons);
#line 107 "../src/Objects/PrinterManager.vala"
				_tmp12_ = printer;
#line 107 "../src/Objects/PrinterManager.vala"
				printers_printer_set_is_accepting_jobs (_tmp12_, is_accepting_jobs);
#line 108 "../src/Objects/PrinterManager.vala"
				_tmp13_ = printer;
#line 108 "../src/Objects/PrinterManager.vala"
				_tmp14_ = g_strdup_printf ("%u", state);
#line 108 "../src/Objects/PrinterManager.vala"
				_tmp15_ = _tmp14_;
#line 108 "../src/Objects/PrinterManager.vala"
				printers_printer_set_state (_tmp13_, _tmp15_);
#line 108 "../src/Objects/PrinterManager.vala"
				_g_free0 (_tmp15_);
#line 109 "../src/Objects/PrinterManager.vala"
				_tmp16_ = printer;
#line 109 "../src/Objects/PrinterManager.vala"
				g_object_notify ((GObject*) _tmp16_, "state");
#line 110 "../src/Objects/PrinterManager.vala"
				_tmp17_ = printer;
#line 110 "../src/Objects/PrinterManager.vala"
				g_object_notify ((GObject*) _tmp17_, "state-reasons");
#line 111 "../src/Objects/PrinterManager.vala"
				_g_object_unref0 (printer);
#line 111 "../src/Objects/PrinterManager.vala"
				break;
#line 893 "PrinterManager.c"
			}
#line 104 "../src/Objects/PrinterManager.vala"
			_g_object_unref0 (printer);
#line 897 "PrinterManager.c"
		}
	}
}

static void
printers_printer_manager_add_printer (PrintersPrinterManager* self,
                                      cups_dest_t* destination)
{
	PrintersPrinter* printer = NULL;
	cups_dest_t _tmp0_;
	PrintersPrinter* _tmp1_;
	GeeLinkedList* _tmp2_;
#line 116 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (destination != NULL);
#line 117 "../src/Objects/PrinterManager.vala"
	_tmp0_ = *destination;
#line 117 "../src/Objects/PrinterManager.vala"
	_tmp1_ = printers_printer_new (&_tmp0_);
#line 117 "../src/Objects/PrinterManager.vala"
	printer = _tmp1_;
#line 118 "../src/Objects/PrinterManager.vala"
	_tmp2_ = self->priv->printers;
#line 118 "../src/Objects/PrinterManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, printer);
#line 119 "../src/Objects/PrinterManager.vala"
	g_signal_emit (self, printers_printer_manager_signals[PRINTERS_PRINTER_MANAGER_PRINTER_ADDED_SIGNAL], 0, printer);
#line 116 "../src/Objects/PrinterManager.vala"
	_g_object_unref0 (printer);
#line 928 "PrinterManager.c"
}

static void
printers_printer_manager_new_subscription_data_free (gpointer _data)
{
	PrintersPrinterManagerNewSubscriptionData* _data_;
	_data_ = _data;
#line 22 "../src/Objects/PrinterManager.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Objects/PrinterManager.vala"
	g_slice_free (PrintersPrinterManagerNewSubscriptionData, _data_);
#line 940 "PrinterManager.c"
}

static void
printers_printer_manager_new_subscription (PrintersPrinterManager* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	PrintersPrinterManagerNewSubscriptionData* _data_;
	PrintersPrinterManager* _tmp0_;
#line 22 "../src/Objects/PrinterManager.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Objects/PrinterManager.vala"
	_data_ = g_slice_new0 (PrintersPrinterManagerNewSubscriptionData);
#line 22 "../src/Objects/PrinterManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Objects/PrinterManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, printers_printer_manager_new_subscription_data_free);
#line 22 "../src/Objects/PrinterManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Objects/PrinterManager.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_new_subscription_co (_data_);
#line 964 "PrinterManager.c"
}

static void
printers_printer_manager_new_subscription_finish (PrintersPrinterManager* self,
                                                  GAsyncResult* _res_)
{
	PrintersPrinterManagerNewSubscriptionData* _data_;
#line 22 "../src/Objects/PrinterManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 974 "PrinterManager.c"
}

static gboolean
printers_printer_manager_new_subscription_co (PrintersPrinterManagerNewSubscriptionData* _data_)
{
#line 134 "../src/Objects/PrinterManager.vala"
	switch (_data_->_state_) {
#line 134 "../src/Objects/PrinterManager.vala"
		case 0:
#line 984 "PrinterManager.c"
		goto _state_0;
		default:
#line 134 "../src/Objects/PrinterManager.vala"
		g_assert_not_reached ();
#line 989 "PrinterManager.c"
	}
	_state_0:
#line 135 "../src/Objects/PrinterManager.vala"
	_data_->request = NULL;
#line 136 "../src/Objects/PrinterManager.vala"
	if (_data_->self->priv->subscription_id <= 0) {
#line 137 "../src/Objects/PrinterManager.vala"
		_data_->_tmp0_ = ippNewRequest (IPP_CREATE_PRINTER_SUBSCRIPTION);
#line 137 "../src/Objects/PrinterManager.vala"
		_ippDelete0 (_data_->request);
#line 137 "../src/Objects/PrinterManager.vala"
		_data_->request = _data_->_tmp0_;
#line 138 "../src/Objects/PrinterManager.vala"
		_data_->_tmp1_ = _data_->request;
#line 138 "../src/Objects/PrinterManager.vala"
		ippAddStrings (_data_->_tmp1_, IPP_TAG_SUBSCRIPTION, IPP_TAG_KEYWORD, "notify-events", (gint) G_N_ELEMENTS (PRINTERS_PRINTER_MANAGER_SUBSCRIPTION_EVENTS), NULL, PRINTERS_PRINTER_MANAGER_SUBSCRIPTION_EVENTS);
#line 139 "../src/Objects/PrinterManager.vala"
		_data_->_tmp2_ = _data_->request;
#line 139 "../src/Objects/PrinterManager.vala"
		ippAddString (_data_->_tmp2_, IPP_TAG_SUBSCRIPTION, IPP_TAG_KEYWORD, "notify-pull-method", NULL, "ippget");
#line 140 "../src/Objects/PrinterManager.vala"
		_data_->_tmp3_ = _data_->request;
#line 140 "../src/Objects/PrinterManager.vala"
		ippAddString (_data_->_tmp3_, IPP_TAG_SUBSCRIPTION, IPP_TAG_URI, "notify-recipient-uri", NULL, "dbus://");
#line 1014 "PrinterManager.c"
	} else {
#line 142 "../src/Objects/PrinterManager.vala"
		_data_->_tmp4_ = ippNewRequest (IPP_RENEW_SUBSCRIPTION);
#line 142 "../src/Objects/PrinterManager.vala"
		_ippDelete0 (_data_->request);
#line 142 "../src/Objects/PrinterManager.vala"
		_data_->request = _data_->_tmp4_;
#line 143 "../src/Objects/PrinterManager.vala"
		_data_->_tmp5_ = _data_->request;
#line 143 "../src/Objects/PrinterManager.vala"
		ippAddInteger (_data_->_tmp5_, IPP_TAG_OPERATION, IPP_TAG_INTEGER, "notify-subscription-id", _data_->self->priv->subscription_id);
#line 1026 "PrinterManager.c"
	}
#line 146 "../src/Objects/PrinterManager.vala"
	_data_->_tmp6_ = _data_->request;
#line 146 "../src/Objects/PrinterManager.vala"
	ippAddString (_data_->_tmp6_, IPP_TAG_OPERATION, IPP_TAG_URI, "printer-uri", NULL, "/");
#line 147 "../src/Objects/PrinterManager.vala"
	_data_->_tmp7_ = _data_->request;
#line 147 "../src/Objects/PrinterManager.vala"
	_data_->_tmp8_ = cupsUser ();
#line 147 "../src/Objects/PrinterManager.vala"
	ippAddString (_data_->_tmp7_, IPP_TAG_OPERATION, IPP_TAG_NAME, "requesting-user-name", NULL, _data_->_tmp8_);
#line 148 "../src/Objects/PrinterManager.vala"
	_data_->_tmp9_ = _data_->request;
#line 148 "../src/Objects/PrinterManager.vala"
	ippAddInteger (_data_->_tmp9_, IPP_TAG_SUBSCRIPTION, IPP_TAG_INTEGER, "notify-lease-duration", PRINTERS_PRINTER_MANAGER_SUBSCRIPTION_DURATION);
#line 149 "../src/Objects/PrinterManager.vala"
	_data_->_tmp10_ = CUPS_HTTP_DEFAULT;
#line 149 "../src/Objects/PrinterManager.vala"
	_data_->request = cupsDoRequest (_data_->_tmp10_, _data_->request, "/");
#line 150 "../src/Objects/PrinterManager.vala"
	_data_->_tmp12_ = _data_->request;
#line 150 "../src/Objects/PrinterManager.vala"
	if (_data_->_tmp12_ != NULL) {
#line 150 "../src/Objects/PrinterManager.vala"
		_data_->_tmp13_ = _data_->request;
#line 150 "../src/Objects/PrinterManager.vala"
		_data_->_tmp11_ = ippGetStatusCode (_data_->_tmp13_) <= IPP_OK_CONFLICT;
#line 1054 "PrinterManager.c"
	} else {
#line 150 "../src/Objects/PrinterManager.vala"
		_data_->_tmp11_ = FALSE;
#line 1058 "PrinterManager.c"
	}
#line 150 "../src/Objects/PrinterManager.vala"
	if (_data_->_tmp11_) {
#line 151 "../src/Objects/PrinterManager.vala"
		_data_->_tmp14_ = _data_->request;
#line 151 "../src/Objects/PrinterManager.vala"
		_data_->_tmp15_ = ippFindAttribute (_data_->_tmp14_, "notify-subscription-id", IPP_TAG_INTEGER);
#line 151 "../src/Objects/PrinterManager.vala"
		_data_->attr = _data_->_tmp15_;
#line 152 "../src/Objects/PrinterManager.vala"
		_data_->_tmp16_ = _data_->attr;
#line 152 "../src/Objects/PrinterManager.vala"
		if (_data_->_tmp16_ != NULL) {
#line 153 "../src/Objects/PrinterManager.vala"
			_data_->_tmp17_ = _data_->attr;
#line 153 "../src/Objects/PrinterManager.vala"
			_data_->self->priv->subscription_id = ippGetInteger (_data_->_tmp17_, 0);
#line 1076 "PrinterManager.c"
		} else {
#line 155 "../src/Objects/PrinterManager.vala"
			g_critical ("PrinterManager.vala:155: No notify-subscription-id in response!");
#line 1080 "PrinterManager.c"
		}
	}
#line 134 "../src/Objects/PrinterManager.vala"
	_ippDelete0 (_data_->request);
#line 134 "../src/Objects/PrinterManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 134 "../src/Objects/PrinterManager.vala"
	if (_data_->_state_ != 0) {
#line 134 "../src/Objects/PrinterManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 134 "../src/Objects/PrinterManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1093 "PrinterManager.c"
		}
	}
#line 134 "../src/Objects/PrinterManager.vala"
	g_object_unref (_data_->_async_result);
#line 134 "../src/Objects/PrinterManager.vala"
	return FALSE;
#line 1100 "PrinterManager.c"
}

static void
printers_printer_manager_class_init (PrintersPrinterManagerClass * klass,
                                     gpointer klass_data)
{
#line 22 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/PrinterManager.vala"
	g_type_class_adjust_private_offset (klass, &PrintersPrinterManager_private_offset);
#line 22 "../src/Objects/PrinterManager.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_printer_manager_finalize;
#line 22 "../src/Objects/PrinterManager.vala"
	printers_printer_manager_signals[PRINTERS_PRINTER_MANAGER_PRINTER_ADDED_SIGNAL] = g_signal_new ("printer-added", PRINTERS_TYPE_PRINTER_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PRINTERS_TYPE_PRINTER);
#line 1115 "PrinterManager.c"
}

static void
printers_printer_manager_instance_init (PrintersPrinterManager * self,
                                        gpointer klass)
{
#line 22 "../src/Objects/PrinterManager.vala"
	self->priv = printers_printer_manager_get_instance_private (self);
#line 37 "../src/Objects/PrinterManager.vala"
	self->priv->subscription_id = -1;
#line 1126 "PrinterManager.c"
}

static void
printers_printer_manager_finalize (GObject * obj)
{
	PrintersPrinterManager * self;
#line 22 "../src/Objects/PrinterManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_PRINTER_MANAGER, PrintersPrinterManager);
#line 38 "../src/Objects/PrinterManager.vala"
	_g_object_unref0 (self->priv->printers);
#line 22 "../src/Objects/PrinterManager.vala"
	G_OBJECT_CLASS (printers_printer_manager_parent_class)->finalize (obj);
#line 1139 "PrinterManager.c"
}

static GType
printers_printer_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersPrinterManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_printer_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersPrinterManager), 0, (GInstanceInitFunc) printers_printer_manager_instance_init, NULL };
	GType printers_printer_manager_type_id;
	printers_printer_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PrintersPrinterManager", &g_define_type_info, 0);
	PrintersPrinterManager_private_offset = g_type_add_instance_private (printers_printer_manager_type_id, sizeof (PrintersPrinterManagerPrivate));
	return printers_printer_manager_type_id;
}

GType
printers_printer_manager_get_type (void)
{
	static volatile gsize printers_printer_manager_type_id__once = 0;
	if (g_once_init_enter (&printers_printer_manager_type_id__once)) {
		GType printers_printer_manager_type_id;
		printers_printer_manager_type_id = printers_printer_manager_get_type_once ();
		g_once_init_leave (&printers_printer_manager_type_id__once, printers_printer_manager_type_id);
	}
	return printers_printer_manager_type_id__once;
}

