/* JobsView.c generated by valac 0.56.17, the Vala compiler
 * generated from JobsView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2015 - 2022 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "printers.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include "cups/cups.h"
#include <gee.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PRINTERS_JOBS_VIEW_0_PROPERTY,
	PRINTERS_JOBS_VIEW_NUM_PROPERTIES
};
static GParamSpec* printers_jobs_view_properties[PRINTERS_JOBS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block9Data Block9Data;

struct _PrintersJobsViewPrivate {
	PrintersPrinter* printer;
	GtkListBox* list_box;
	GtkButton* clear_button;
};

struct _Block8Data {
	int _ref_count_;
	PrintersJobsView* self;
	PrintersPrinter* printer;
};

struct _Block9Data {
	int _ref_count_;
	PrintersJobsView* self;
	PrintersClearQueueDialog* dialog;
};

static gint PrintersJobsView_private_offset;
static gpointer printers_jobs_view_parent_class = NULL;

static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void printers_jobs_view_update_header (PrintersJobRow* row1,
                                       PrintersJobRow* row2,
                                       PrintersJobsView* self);
static gint printers_jobs_view_compare (PrintersJobRow* a,
                                 PrintersJobRow* b);
static void printers_jobs_view_refresh_job_list (PrintersJobsView* self);
static void __lambda9_ (Block8Data* _data8_,
                 const gchar* text,
                 const gchar* printer_uri,
                 const gchar* name,
                 guint32 state,
                 const gchar* state_reasons,
                 gboolean is_accepting_jobs,
                 guint32 job_id,
                 guint32 job_state,
                 const gchar* job_state_reason,
                 const gchar* job_name,
                 guint32 job_impressions_completed);
static void ___lambda9__cups_notifier_job_created (CupsNotifier* _sender,
                                            const gchar* text,
                                            const gchar* printer_uri,
                                            const gchar* name,
                                            guint32 state,
                                            const gchar* state_reasons,
                                            gboolean is_accepting_jobs,
                                            guint32 job_id,
                                            guint32 job_state,
                                            const gchar* job_state_reason,
                                            const gchar* job_name,
                                            guint32 job_impressions_completed,
                                            gpointer self);
static void __lambda10_ (PrintersJobsView* self);
static void ___lambda10__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda11_ (Block9Data* _data9_,
                  gint response_id);
static void ___lambda12_ (PrintersJobsView* self,
                   GtkWidget* row);
static void ____lambda12__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void ___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __lambda8_ (PrintersJobsView* self,
                 GtkWidget* row);
static void ___lambda8__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void printers_jobs_view_finalize (GObject * obj);
static GType printers_jobs_view_get_type_once (void);

static inline gpointer
printers_jobs_view_get_instance_private (PrintersJobsView* self)
{
	return G_STRUCT_MEMBER_P (self, PrintersJobsView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/Views/JobsView.vala"
	return self ? g_object_ref (self) : NULL;
#line 145 "JobsView.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 28 "../src/Views/JobsView.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 28 "../src/Views/JobsView.vala"
	return _data8_;
#line 155 "JobsView.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 28 "../src/Views/JobsView.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 165 "JobsView.c"
		PrintersJobsView* self;
#line 28 "../src/Views/JobsView.vala"
		self = _data8_->self;
#line 28 "../src/Views/JobsView.vala"
		_g_object_unref0 (_data8_->printer);
#line 28 "../src/Views/JobsView.vala"
		_g_object_unref0 (self);
#line 28 "../src/Views/JobsView.vala"
		g_slice_free (Block8Data, _data8_);
#line 175 "JobsView.c"
	}
}

static void
__lambda9_ (Block8Data* _data8_,
            const gchar* text,
            const gchar* printer_uri,
            const gchar* name,
            guint32 state,
            const gchar* state_reasons,
            gboolean is_accepting_jobs,
            guint32 job_id,
            guint32 job_state,
            const gchar* job_state_reason,
            const gchar* job_name,
            guint32 job_impressions_completed)
{
	PrintersJobsView* self;
	cups_dest_t _tmp0_;
	const gchar* _tmp1_;
	GeeTreeSet* jobs_ = NULL;
	GeeTreeSet* _tmp2_;
	GtkButton* _tmp15_;
	GtkListBox* _tmp16_;
	GList* _tmp17_;
	GList* _tmp18_;
#line 65 "../src/Views/JobsView.vala"
	self = _data8_->self;
#line 65 "../src/Views/JobsView.vala"
	g_return_if_fail (text != NULL);
#line 65 "../src/Views/JobsView.vala"
	g_return_if_fail (printer_uri != NULL);
#line 65 "../src/Views/JobsView.vala"
	g_return_if_fail (name != NULL);
#line 65 "../src/Views/JobsView.vala"
	g_return_if_fail (state_reasons != NULL);
#line 65 "../src/Views/JobsView.vala"
	g_return_if_fail (job_state_reason != NULL);
#line 65 "../src/Views/JobsView.vala"
	g_return_if_fail (job_name != NULL);
#line 66 "../src/Views/JobsView.vala"
	_tmp0_ = _data8_->printer->dest;
#line 66 "../src/Views/JobsView.vala"
	_tmp1_ = _tmp0_.name;
#line 66 "../src/Views/JobsView.vala"
	if (g_strcmp0 (_tmp1_, name) != 0) {
#line 67 "../src/Views/JobsView.vala"
		return;
#line 224 "JobsView.c"
	}
#line 70 "../src/Views/JobsView.vala"
	_tmp2_ = printers_printer_get_jobs (_data8_->printer, TRUE, CUPS_WHICHJOBS_ALL);
#line 70 "../src/Views/JobsView.vala"
	jobs_ = _tmp2_;
#line 230 "JobsView.c"
	{
		GeeIterator* _job_it = NULL;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
#line 71 "../src/Views/JobsView.vala"
		_tmp3_ = jobs_;
#line 71 "../src/Views/JobsView.vala"
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
#line 71 "../src/Views/JobsView.vala"
		_job_it = _tmp4_;
#line 71 "../src/Views/JobsView.vala"
		while (TRUE) {
#line 243 "JobsView.c"
			GeeIterator* _tmp5_;
			PrintersJob* job = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			PrintersJob* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 71 "../src/Views/JobsView.vala"
			_tmp5_ = _job_it;
#line 71 "../src/Views/JobsView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 71 "../src/Views/JobsView.vala"
				break;
#line 257 "JobsView.c"
			}
#line 71 "../src/Views/JobsView.vala"
			_tmp6_ = _job_it;
#line 71 "../src/Views/JobsView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 71 "../src/Views/JobsView.vala"
			job = (PrintersJob*) _tmp7_;
#line 72 "../src/Views/JobsView.vala"
			_tmp8_ = job;
#line 72 "../src/Views/JobsView.vala"
			_tmp9_ = printers_job_get_uid (_tmp8_);
#line 72 "../src/Views/JobsView.vala"
			_tmp10_ = _tmp9_;
#line 72 "../src/Views/JobsView.vala"
			if (((guint32) _tmp10_) == job_id) {
#line 273 "JobsView.c"
				GtkListBox* _tmp11_;
				PrintersJob* _tmp12_;
				PrintersJobRow* _tmp13_;
				PrintersJobRow* _tmp14_;
#line 73 "../src/Views/JobsView.vala"
				_tmp11_ = self->priv->list_box;
#line 73 "../src/Views/JobsView.vala"
				_tmp12_ = job;
#line 73 "../src/Views/JobsView.vala"
				_tmp13_ = printers_job_row_new (_data8_->printer, _tmp12_);
#line 73 "../src/Views/JobsView.vala"
				g_object_ref_sink (_tmp13_);
#line 73 "../src/Views/JobsView.vala"
				_tmp14_ = _tmp13_;
#line 73 "../src/Views/JobsView.vala"
				gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp14_);
#line 73 "../src/Views/JobsView.vala"
				_g_object_unref0 (_tmp14_);
#line 74 "../src/Views/JobsView.vala"
				_g_object_unref0 (job);
#line 74 "../src/Views/JobsView.vala"
				break;
#line 296 "JobsView.c"
			}
#line 71 "../src/Views/JobsView.vala"
			_g_object_unref0 (job);
#line 300 "JobsView.c"
		}
#line 71 "../src/Views/JobsView.vala"
		_g_object_unref0 (_job_it);
#line 304 "JobsView.c"
	}
#line 78 "../src/Views/JobsView.vala"
	_tmp15_ = self->priv->clear_button;
#line 78 "../src/Views/JobsView.vala"
	_tmp16_ = self->priv->list_box;
#line 78 "../src/Views/JobsView.vala"
	_tmp17_ = gtk_container_get_children ((GtkContainer*) _tmp16_);
#line 78 "../src/Views/JobsView.vala"
	_tmp18_ = _tmp17_;
#line 78 "../src/Views/JobsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, g_list_length (_tmp18_) > ((guint) 0));
#line 78 "../src/Views/JobsView.vala"
	(_tmp18_ == NULL) ? NULL : (_tmp18_ = (g_list_free (_tmp18_), NULL));
#line 65 "../src/Views/JobsView.vala"
	_g_object_unref0 (jobs_);
#line 320 "JobsView.c"
}

static void
___lambda9__cups_notifier_job_created (CupsNotifier* _sender,
                                       const gchar* text,
                                       const gchar* printer_uri,
                                       const gchar* name,
                                       guint32 state,
                                       const gchar* state_reasons,
                                       gboolean is_accepting_jobs,
                                       guint32 job_id,
                                       guint32 job_state,
                                       const gchar* job_state_reason,
                                       const gchar* job_name,
                                       guint32 job_impressions_completed,
                                       gpointer self)
{
#line 65 "../src/Views/JobsView.vala"
	__lambda9_ (self, text, printer_uri, name, state, state_reasons, is_accepting_jobs, job_id, job_state, job_state_reason, job_name, job_impressions_completed);
#line 340 "JobsView.c"
}

static void
__lambda10_ (PrintersJobsView* self)
{
#line 81 "../src/Views/JobsView.vala"
	printers_jobs_view_clear_queue (self);
#line 348 "JobsView.c"
}

static void
___lambda10__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 81 "../src/Views/JobsView.vala"
	__lambda10_ ((PrintersJobsView*) self);
#line 357 "JobsView.c"
}

PrintersJobsView*
printers_jobs_view_construct (GType object_type,
                              PrintersPrinter* printer)
{
	PrintersJobsView * self = NULL;
	Block8Data* _data8_;
	PrintersPrinter* _tmp0_;
	PrintersPrinter* _tmp1_;
	GraniteWidgetsAlertView* alert = NULL;
	GraniteWidgetsAlertView* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GtkListBox* _tmp7_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp8_;
	GtkListBox* _tmp9_;
	GtkImage* _tmp10_;
	GtkListBox* _tmp11_;
	GList* _tmp12_;
	GList* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkButton* _tmp19_;
	GtkBox* box = NULL;
	GtkBox* _tmp20_;
	CupsNotifier* notifier = NULL;
	CupsNotifier* _tmp21_;
	GtkButton* _tmp22_;
#line 28 "../src/Views/JobsView.vala"
	g_return_val_if_fail (printer != NULL, NULL);
#line 28 "../src/Views/JobsView.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 28 "../src/Views/JobsView.vala"
	_data8_->_ref_count_ = 1;
#line 28 "../src/Views/JobsView.vala"
	_tmp0_ = _g_object_ref0 (printer);
#line 28 "../src/Views/JobsView.vala"
	_g_object_unref0 (_data8_->printer);
#line 28 "../src/Views/JobsView.vala"
	_data8_->printer = _tmp0_;
#line 28 "../src/Views/JobsView.vala"
	self = (PrintersJobsView*) g_object_new (object_type, NULL);
#line 28 "../src/Views/JobsView.vala"
	_data8_->self = g_object_ref (self);
#line 29 "../src/Views/JobsView.vala"
	_tmp1_ = _g_object_ref0 (_data8_->printer);
#line 29 "../src/Views/JobsView.vala"
	_g_object_unref0 (self->priv->printer);
#line 29 "../src/Views/JobsView.vala"
	self->priv->printer = _tmp1_;
#line 31 "../src/Views/JobsView.vala"
	_tmp2_ = granite_widgets_alert_view_new (_ ("Print Queue Is Empty"), _ ("There are no pending jobs in the queue."), "");
#line 31 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp2_);
#line 31 "../src/Views/JobsView.vala"
	alert = _tmp2_;
#line 32 "../src/Views/JobsView.vala"
	gtk_widget_show_all ((GtkWidget*) alert);
#line 34 "../src/Views/JobsView.vala"
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
#line 34 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp3_);
#line 34 "../src/Views/JobsView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 34 "../src/Views/JobsView.vala"
	self->priv->list_box = _tmp3_;
#line 35 "../src/Views/JobsView.vala"
	_tmp4_ = self->priv->list_box;
#line 35 "../src/Views/JobsView.vala"
	gtk_list_box_set_selection_mode (_tmp4_, GTK_SELECTION_SINGLE);
#line 36 "../src/Views/JobsView.vala"
	_tmp5_ = self->priv->list_box;
#line 36 "../src/Views/JobsView.vala"
	gtk_list_box_set_placeholder (_tmp5_, (GtkWidget*) alert);
#line 37 "../src/Views/JobsView.vala"
	_tmp6_ = self->priv->list_box;
#line 37 "../src/Views/JobsView.vala"
	gtk_list_box_set_header_func (_tmp6_, (GtkListBoxUpdateHeaderFunc) printers_jobs_view_update_header, g_object_ref (self), g_object_unref);
#line 38 "../src/Views/JobsView.vala"
	_tmp7_ = self->priv->list_box;
#line 38 "../src/Views/JobsView.vala"
	gtk_list_box_set_sort_func (_tmp7_, (GtkListBoxSortFunc) printers_jobs_view_compare, NULL, NULL);
#line 40 "../src/Views/JobsView.vala"
	_tmp8_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 40 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp8_);
#line 40 "../src/Views/JobsView.vala"
	scrolled = _tmp8_;
#line 41 "../src/Views/JobsView.vala"
	g_object_set ((GtkWidget*) scrolled, "expand", TRUE, NULL);
#line 42 "../src/Views/JobsView.vala"
	_tmp9_ = self->priv->list_box;
#line 42 "../src/Views/JobsView.vala"
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) _tmp9_);
#line 43 "../src/Views/JobsView.vala"
	gtk_widget_show_all ((GtkWidget*) scrolled);
#line 45 "../src/Views/JobsView.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-clear-all-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 45 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp10_);
#line 45 "../src/Views/JobsView.vala"
	_tmp11_ = self->priv->list_box;
#line 45 "../src/Views/JobsView.vala"
	_tmp12_ = gtk_container_get_children ((GtkContainer*) _tmp11_);
#line 45 "../src/Views/JobsView.vala"
	_tmp13_ = _tmp12_;
#line 45 "../src/Views/JobsView.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_with_label (_ ("Clear All"));
#line 45 "../src/Views/JobsView.vala"
	gtk_button_set_always_show_image (_tmp14_, TRUE);
#line 45 "../src/Views/JobsView.vala"
	gtk_button_set_image (_tmp14_, (GtkWidget*) _tmp10_);
#line 45 "../src/Views/JobsView.vala"
	_g_object_unref0 (_tmp10_);
#line 45 "../src/Views/JobsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, g_list_length (_tmp13_) > ((guint) 0));
#line 45 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp14_);
#line 45 "../src/Views/JobsView.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 45 "../src/Views/JobsView.vala"
	self->priv->clear_button = _tmp14_;
#line 45 "../src/Views/JobsView.vala"
	(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_list_free (_tmp13_), NULL));
#line 50 "../src/Views/JobsView.vala"
	_tmp15_ = self->priv->clear_button;
#line 50 "../src/Views/JobsView.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 50 "../src/Views/JobsView.vala"
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_FLAT);
#line 52 "../src/Views/JobsView.vala"
	_tmp17_ = (GtkActionBar*) gtk_action_bar_new ();
#line 52 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp17_);
#line 52 "../src/Views/JobsView.vala"
	actionbar = _tmp17_;
#line 53 "../src/Views/JobsView.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) actionbar);
#line 53 "../src/Views/JobsView.vala"
	gtk_style_context_add_class (_tmp18_, GTK_STYLE_CLASS_FLAT);
#line 54 "../src/Views/JobsView.vala"
	_tmp19_ = self->priv->clear_button;
#line 54 "../src/Views/JobsView.vala"
	gtk_container_add ((GtkContainer*) actionbar, (GtkWidget*) _tmp19_);
#line 56 "../src/Views/JobsView.vala"
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 56 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp20_);
#line 56 "../src/Views/JobsView.vala"
	box = _tmp20_;
#line 57 "../src/Views/JobsView.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) scrolled);
#line 58 "../src/Views/JobsView.vala"
	gtk_container_add ((GtkContainer*) box, (GtkWidget*) actionbar);
#line 60 "../src/Views/JobsView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) box);
#line 62 "../src/Views/JobsView.vala"
	printers_jobs_view_refresh_job_list (self);
#line 64 "../src/Views/JobsView.vala"
	_tmp21_ = cups_notifier_get_default ();
#line 64 "../src/Views/JobsView.vala"
	notifier = _tmp21_;
#line 65 "../src/Views/JobsView.vala"
	g_signal_connect_data (notifier, "job-created", (GCallback) ___lambda9__cups_notifier_job_created, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 81 "../src/Views/JobsView.vala"
	_tmp22_ = self->priv->clear_button;
#line 81 "../src/Views/JobsView.vala"
	g_signal_connect_object (_tmp22_, "clicked", (GCallback) ___lambda10__gtk_button_clicked, self, 0);
#line 28 "../src/Views/JobsView.vala"
	_g_object_unref0 (box);
#line 28 "../src/Views/JobsView.vala"
	_g_object_unref0 (actionbar);
#line 28 "../src/Views/JobsView.vala"
	_g_object_unref0 (scrolled);
#line 28 "../src/Views/JobsView.vala"
	_g_object_unref0 (alert);
#line 28 "../src/Views/JobsView.vala"
	block8_data_unref (_data8_);
#line 28 "../src/Views/JobsView.vala"
	_data8_ = NULL;
#line 28 "../src/Views/JobsView.vala"
	return self;
#line 548 "JobsView.c"
}

PrintersJobsView*
printers_jobs_view_new (PrintersPrinter* printer)
{
#line 28 "../src/Views/JobsView.vala"
	return printers_jobs_view_construct (PRINTERS_TYPE_JOBS_VIEW, printer);
#line 556 "JobsView.c"
}

static gint
printers_jobs_view_compare (PrintersJobRow* a,
                            PrintersJobRow* b)
{
	gboolean _tmp0_ = FALSE;
	PrintersJob* _tmp1_;
	PrintersJob* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gint result;
#line 85 "../src/Views/JobsView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 85 "../src/Views/JobsView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 86 "../src/Views/JobsView.vala"
	_tmp1_ = printers_job_row_get_job (a);
#line 86 "../src/Views/JobsView.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/Views/JobsView.vala"
	_tmp3_ = printers_job_get_is_ongoing (_tmp2_);
#line 86 "../src/Views/JobsView.vala"
	_tmp4_ = _tmp3_;
#line 86 "../src/Views/JobsView.vala"
	if (_tmp4_) {
#line 583 "JobsView.c"
		PrintersJob* _tmp5_;
		PrintersJob* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 86 "../src/Views/JobsView.vala"
		_tmp5_ = printers_job_row_get_job (b);
#line 86 "../src/Views/JobsView.vala"
		_tmp6_ = _tmp5_;
#line 86 "../src/Views/JobsView.vala"
		_tmp7_ = printers_job_get_is_ongoing (_tmp6_);
#line 86 "../src/Views/JobsView.vala"
		_tmp8_ = _tmp7_;
#line 86 "../src/Views/JobsView.vala"
		_tmp0_ = !_tmp8_;
#line 598 "JobsView.c"
	} else {
#line 86 "../src/Views/JobsView.vala"
		_tmp0_ = FALSE;
#line 602 "JobsView.c"
	}
#line 86 "../src/Views/JobsView.vala"
	if (_tmp0_) {
#line 87 "../src/Views/JobsView.vala"
		result = -1;
#line 87 "../src/Views/JobsView.vala"
		return result;
#line 610 "JobsView.c"
	} else {
		gboolean _tmp9_ = FALSE;
		PrintersJob* _tmp10_;
		PrintersJob* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 88 "../src/Views/JobsView.vala"
		_tmp10_ = printers_job_row_get_job (a);
#line 88 "../src/Views/JobsView.vala"
		_tmp11_ = _tmp10_;
#line 88 "../src/Views/JobsView.vala"
		_tmp12_ = printers_job_get_is_ongoing (_tmp11_);
#line 88 "../src/Views/JobsView.vala"
		_tmp13_ = _tmp12_;
#line 88 "../src/Views/JobsView.vala"
		if (!_tmp13_) {
#line 627 "JobsView.c"
			PrintersJob* _tmp14_;
			PrintersJob* _tmp15_;
			gboolean _tmp16_;
			gboolean _tmp17_;
#line 88 "../src/Views/JobsView.vala"
			_tmp14_ = printers_job_row_get_job (b);
#line 88 "../src/Views/JobsView.vala"
			_tmp15_ = _tmp14_;
#line 88 "../src/Views/JobsView.vala"
			_tmp16_ = printers_job_get_is_ongoing (_tmp15_);
#line 88 "../src/Views/JobsView.vala"
			_tmp17_ = _tmp16_;
#line 88 "../src/Views/JobsView.vala"
			_tmp9_ = _tmp17_;
#line 642 "JobsView.c"
		} else {
#line 88 "../src/Views/JobsView.vala"
			_tmp9_ = FALSE;
#line 646 "JobsView.c"
		}
#line 88 "../src/Views/JobsView.vala"
		if (_tmp9_) {
#line 89 "../src/Views/JobsView.vala"
			result = 1;
#line 89 "../src/Views/JobsView.vala"
			return result;
#line 654 "JobsView.c"
		} else {
			GDateTime* timea = NULL;
			PrintersJob* _tmp18_;
			PrintersJob* _tmp19_;
			GDateTime* _tmp20_;
			GDateTime* timeb = NULL;
			PrintersJob* _tmp21_;
			PrintersJob* _tmp22_;
			GDateTime* _tmp23_;
			GDateTime* _tmp24_;
#line 91 "../src/Views/JobsView.vala"
			_tmp18_ = printers_job_row_get_job (G_TYPE_CHECK_INSTANCE_CAST (a, PRINTERS_TYPE_JOB_ROW, PrintersJobRow));
#line 91 "../src/Views/JobsView.vala"
			_tmp19_ = _tmp18_;
#line 91 "../src/Views/JobsView.vala"
			_tmp20_ = printers_job_get_display_time (_tmp19_);
#line 91 "../src/Views/JobsView.vala"
			timea = _tmp20_;
#line 92 "../src/Views/JobsView.vala"
			_tmp21_ = printers_job_row_get_job (G_TYPE_CHECK_INSTANCE_CAST (b, PRINTERS_TYPE_JOB_ROW, PrintersJobRow));
#line 92 "../src/Views/JobsView.vala"
			_tmp22_ = _tmp21_;
#line 92 "../src/Views/JobsView.vala"
			_tmp23_ = printers_job_get_display_time (_tmp22_);
#line 92 "../src/Views/JobsView.vala"
			timeb = _tmp23_;
#line 93 "../src/Views/JobsView.vala"
			_tmp24_ = timea;
#line 93 "../src/Views/JobsView.vala"
			if (_tmp24_ == NULL) {
#line 685 "JobsView.c"
				GDateTime* _tmp25_;
#line 94 "../src/Views/JobsView.vala"
				_tmp25_ = timeb;
#line 94 "../src/Views/JobsView.vala"
				if (_tmp25_ == NULL) {
#line 95 "../src/Views/JobsView.vala"
					result = 0;
#line 95 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timeb);
#line 95 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timea);
#line 95 "../src/Views/JobsView.vala"
					return result;
#line 699 "JobsView.c"
				} else {
#line 97 "../src/Views/JobsView.vala"
					result = 1;
#line 97 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timeb);
#line 97 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timea);
#line 97 "../src/Views/JobsView.vala"
					return result;
#line 709 "JobsView.c"
				}
			} else {
				GDateTime* _tmp26_;
#line 99 "../src/Views/JobsView.vala"
				_tmp26_ = timeb;
#line 99 "../src/Views/JobsView.vala"
				if (_tmp26_ == NULL) {
#line 100 "../src/Views/JobsView.vala"
					result = -1;
#line 100 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timeb);
#line 100 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timea);
#line 100 "../src/Views/JobsView.vala"
					return result;
#line 725 "JobsView.c"
				} else {
					GDateTime* _tmp27_;
					GDateTime* _tmp28_;
#line 102 "../src/Views/JobsView.vala"
					_tmp27_ = timeb;
#line 102 "../src/Views/JobsView.vala"
					_tmp28_ = timea;
#line 102 "../src/Views/JobsView.vala"
					result = g_date_time_compare (_tmp27_, _tmp28_);
#line 102 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timeb);
#line 102 "../src/Views/JobsView.vala"
					_g_date_time_unref0 (timea);
#line 102 "../src/Views/JobsView.vala"
					return result;
#line 741 "JobsView.c"
				}
			}
#line 88 "../src/Views/JobsView.vala"
			_g_date_time_unref0 (timeb);
#line 88 "../src/Views/JobsView.vala"
			_g_date_time_unref0 (timea);
#line 748 "JobsView.c"
		}
	}
}

static void
printers_jobs_view_update_header (PrintersJobRow* row1,
                                  PrintersJobRow* row2,
                                  PrintersJobsView* self)
{
	gboolean _tmp0_ = FALSE;
	PrintersJob* _tmp1_;
	PrintersJob* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 108 "../src/Views/JobsView.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/Views/JobsView.vala"
	g_return_if_fail (row1 != NULL);
#line 109 "../src/Views/JobsView.vala"
	_tmp1_ = printers_job_row_get_job (row1);
#line 109 "../src/Views/JobsView.vala"
	_tmp2_ = _tmp1_;
#line 109 "../src/Views/JobsView.vala"
	_tmp3_ = printers_job_get_is_ongoing (_tmp2_);
#line 109 "../src/Views/JobsView.vala"
	_tmp4_ = _tmp3_;
#line 109 "../src/Views/JobsView.vala"
	if (!_tmp4_) {
#line 777 "JobsView.c"
		gboolean _tmp5_ = FALSE;
#line 109 "../src/Views/JobsView.vala"
		if (row2 == NULL) {
#line 109 "../src/Views/JobsView.vala"
			_tmp5_ = TRUE;
#line 783 "JobsView.c"
		} else {
			PrintersJob* _tmp6_;
			PrintersJob* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 109 "../src/Views/JobsView.vala"
			_tmp6_ = printers_job_row_get_job (row2);
#line 109 "../src/Views/JobsView.vala"
			_tmp7_ = _tmp6_;
#line 109 "../src/Views/JobsView.vala"
			_tmp8_ = printers_job_get_is_ongoing (_tmp7_);
#line 109 "../src/Views/JobsView.vala"
			_tmp9_ = _tmp8_;
#line 109 "../src/Views/JobsView.vala"
			_tmp5_ = _tmp9_;
#line 799 "JobsView.c"
		}
#line 109 "../src/Views/JobsView.vala"
		_tmp0_ = _tmp5_;
#line 803 "JobsView.c"
	} else {
#line 109 "../src/Views/JobsView.vala"
		_tmp0_ = FALSE;
#line 807 "JobsView.c"
	}
#line 109 "../src/Views/JobsView.vala"
	if (_tmp0_) {
#line 811 "JobsView.c"
		GtkLabel* label = NULL;
		GtkLabel* _tmp10_;
		GtkLabel* _tmp11_;
		GtkLabel* _tmp12_;
		GtkLabel* _tmp13_;
		GtkStyleContext* _tmp14_;
		GtkLabel* _tmp15_;
#line 110 "../src/Views/JobsView.vala"
		_tmp10_ = (GtkLabel*) gtk_label_new (_ ("Completed Jobs"));
#line 110 "../src/Views/JobsView.vala"
		g_object_ref_sink (_tmp10_);
#line 110 "../src/Views/JobsView.vala"
		label = _tmp10_;
#line 111 "../src/Views/JobsView.vala"
		_tmp11_ = label;
#line 111 "../src/Views/JobsView.vala"
		gtk_label_set_xalign (_tmp11_, (gfloat) 0);
#line 112 "../src/Views/JobsView.vala"
		_tmp12_ = label;
#line 112 "../src/Views/JobsView.vala"
		g_object_set ((GtkWidget*) _tmp12_, "margin", 3, NULL);
#line 113 "../src/Views/JobsView.vala"
		_tmp13_ = label;
#line 113 "../src/Views/JobsView.vala"
		_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 113 "../src/Views/JobsView.vala"
		gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 114 "../src/Views/JobsView.vala"
		_tmp15_ = label;
#line 114 "../src/Views/JobsView.vala"
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp15_);
#line 109 "../src/Views/JobsView.vala"
		_g_object_unref0 (label);
#line 845 "JobsView.c"
	} else {
#line 116 "../src/Views/JobsView.vala"
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, NULL);
#line 849 "JobsView.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 120 "../src/Views/JobsView.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 120 "../src/Views/JobsView.vala"
	return _data9_;
#line 860 "JobsView.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 120 "../src/Views/JobsView.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 870 "JobsView.c"
		PrintersJobsView* self;
#line 120 "../src/Views/JobsView.vala"
		self = _data9_->self;
#line 120 "../src/Views/JobsView.vala"
		_g_object_unref0 (_data9_->dialog);
#line 120 "../src/Views/JobsView.vala"
		_g_object_unref0 (self);
#line 120 "../src/Views/JobsView.vala"
		g_slice_free (Block9Data, _data9_);
#line 880 "JobsView.c"
	}
}

static void
___lambda12_ (PrintersJobsView* self,
              GtkWidget* row)
{
	PrintersJob* job = NULL;
	PrintersJob* _tmp0_;
	PrintersJob* _tmp1_;
	PrintersJob* _tmp2_;
#line 128 "../src/Views/JobsView.vala"
	g_return_if_fail (row != NULL);
#line 129 "../src/Views/JobsView.vala"
	_tmp0_ = printers_job_row_get_job (G_TYPE_CHECK_INSTANCE_CAST (row, PRINTERS_TYPE_JOB_ROW, PrintersJobRow));
#line 129 "../src/Views/JobsView.vala"
	_tmp1_ = _tmp0_;
#line 129 "../src/Views/JobsView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 129 "../src/Views/JobsView.vala"
	job = _tmp2_;
#line 130 "../src/Views/JobsView.vala"
	printers_job_pause (job);
#line 131 "../src/Views/JobsView.vala"
	printers_job_purge (job);
#line 128 "../src/Views/JobsView.vala"
	_g_object_unref0 (job);
#line 908 "JobsView.c"
}

static void
____lambda12__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
#line 128 "../src/Views/JobsView.vala"
	___lambda12_ ((PrintersJobsView*) self, widget);
#line 917 "JobsView.c"
}

static void
__lambda11_ (Block9Data* _data9_,
             gint response_id)
{
	PrintersJobsView* self;
#line 124 "../src/Views/JobsView.vala"
	self = _data9_->self;
#line 125 "../src/Views/JobsView.vala"
	gtk_widget_destroy ((GtkWidget*) _data9_->dialog);
#line 127 "../src/Views/JobsView.vala"
	if (response_id == ((gint) GTK_RESPONSE_OK)) {
#line 931 "JobsView.c"
		GtkListBox* _tmp0_;
#line 128 "../src/Views/JobsView.vala"
		_tmp0_ = self->priv->list_box;
#line 128 "../src/Views/JobsView.vala"
		gtk_container_foreach ((GtkContainer*) _tmp0_, ____lambda12__gtk_callback, self);
#line 134 "../src/Views/JobsView.vala"
		printers_jobs_view_refresh_job_list (self);
#line 939 "JobsView.c"
	}
}

static void
___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 124 "../src/Views/JobsView.vala"
	__lambda11_ (self, response_id);
#line 950 "JobsView.c"
}

void
printers_jobs_view_clear_queue (PrintersJobsView* self)
{
	Block9Data* _data9_;
	PrintersPrinter* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWindow* _tmp2_;
	PrintersClearQueueDialog* _tmp3_ = NULL;
#line 120 "../src/Views/JobsView.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Views/JobsView.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 120 "../src/Views/JobsView.vala"
	_data9_->_ref_count_ = 1;
#line 120 "../src/Views/JobsView.vala"
	_data9_->self = g_object_ref (self);
#line 121 "../src/Views/JobsView.vala"
	_tmp0_ = self->priv->printer;
#line 121 "../src/Views/JobsView.vala"
	_tmp1_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 121 "../src/Views/JobsView.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_window_get_type (), GtkWindow));
#line 121 "../src/Views/JobsView.vala"
	_tmp3_ = printers_clear_queue_dialog_new (_tmp0_);
#line 121 "../src/Views/JobsView.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, _tmp2_);
#line 121 "../src/Views/JobsView.vala"
	_g_object_unref0 (_tmp2_);
#line 121 "../src/Views/JobsView.vala"
	g_object_ref_sink (_tmp3_);
#line 121 "../src/Views/JobsView.vala"
	_data9_->dialog = _tmp3_;
#line 124 "../src/Views/JobsView.vala"
	g_signal_connect_data ((GtkDialog*) _data9_->dialog, "response", (GCallback) ___lambda11__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 138 "../src/Views/JobsView.vala"
	gtk_window_present ((GtkWindow*) _data9_->dialog);
#line 120 "../src/Views/JobsView.vala"
	block9_data_unref (_data9_);
#line 120 "../src/Views/JobsView.vala"
	_data9_ = NULL;
#line 993 "JobsView.c"
}

static void
__lambda8_ (PrintersJobsView* self,
            GtkWidget* row)
{
	GtkListBox* _tmp0_;
#line 142 "../src/Views/JobsView.vala"
	g_return_if_fail (row != NULL);
#line 143 "../src/Views/JobsView.vala"
	_tmp0_ = self->priv->list_box;
#line 143 "../src/Views/JobsView.vala"
	gtk_container_remove ((GtkContainer*) _tmp0_, row);
#line 1007 "JobsView.c"
}

static void
___lambda8__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
#line 142 "../src/Views/JobsView.vala"
	__lambda8_ ((PrintersJobsView*) self, widget);
#line 1016 "JobsView.c"
}

static void
printers_jobs_view_refresh_job_list (PrintersJobsView* self)
{
	GtkListBox* _tmp0_;
	GeeTreeSet* jobs = NULL;
	PrintersPrinter* _tmp1_;
	GeeTreeSet* _tmp2_;
	GtkButton* _tmp13_;
	GtkListBox* _tmp14_;
	GList* _tmp15_;
	GList* _tmp16_;
#line 141 "../src/Views/JobsView.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Views/JobsView.vala"
	_tmp0_ = self->priv->list_box;
#line 142 "../src/Views/JobsView.vala"
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda8__gtk_callback, self);
#line 146 "../src/Views/JobsView.vala"
	_tmp1_ = self->priv->printer;
#line 146 "../src/Views/JobsView.vala"
	_tmp2_ = printers_printer_get_jobs (_tmp1_, TRUE, CUPS_WHICHJOBS_ALL);
#line 146 "../src/Views/JobsView.vala"
	jobs = _tmp2_;
#line 1042 "JobsView.c"
	{
		GeeIterator* _job_it = NULL;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
#line 147 "../src/Views/JobsView.vala"
		_tmp3_ = jobs;
#line 147 "../src/Views/JobsView.vala"
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
#line 147 "../src/Views/JobsView.vala"
		_job_it = _tmp4_;
#line 147 "../src/Views/JobsView.vala"
		while (TRUE) {
#line 1055 "JobsView.c"
			GeeIterator* _tmp5_;
			PrintersJob* job = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GtkListBox* _tmp8_;
			PrintersPrinter* _tmp9_;
			PrintersJob* _tmp10_;
			PrintersJobRow* _tmp11_;
			PrintersJobRow* _tmp12_;
#line 147 "../src/Views/JobsView.vala"
			_tmp5_ = _job_it;
#line 147 "../src/Views/JobsView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 147 "../src/Views/JobsView.vala"
				break;
#line 1071 "JobsView.c"
			}
#line 147 "../src/Views/JobsView.vala"
			_tmp6_ = _job_it;
#line 147 "../src/Views/JobsView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 147 "../src/Views/JobsView.vala"
			job = (PrintersJob*) _tmp7_;
#line 148 "../src/Views/JobsView.vala"
			_tmp8_ = self->priv->list_box;
#line 148 "../src/Views/JobsView.vala"
			_tmp9_ = self->priv->printer;
#line 148 "../src/Views/JobsView.vala"
			_tmp10_ = job;
#line 148 "../src/Views/JobsView.vala"
			_tmp11_ = printers_job_row_new (_tmp9_, _tmp10_);
#line 148 "../src/Views/JobsView.vala"
			g_object_ref_sink (_tmp11_);
#line 148 "../src/Views/JobsView.vala"
			_tmp12_ = _tmp11_;
#line 148 "../src/Views/JobsView.vala"
			gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp12_);
#line 148 "../src/Views/JobsView.vala"
			_g_object_unref0 (_tmp12_);
#line 147 "../src/Views/JobsView.vala"
			_g_object_unref0 (job);
#line 1097 "JobsView.c"
		}
#line 147 "../src/Views/JobsView.vala"
		_g_object_unref0 (_job_it);
#line 1101 "JobsView.c"
	}
#line 151 "../src/Views/JobsView.vala"
	_tmp13_ = self->priv->clear_button;
#line 151 "../src/Views/JobsView.vala"
	_tmp14_ = self->priv->list_box;
#line 151 "../src/Views/JobsView.vala"
	_tmp15_ = gtk_container_get_children ((GtkContainer*) _tmp14_);
#line 151 "../src/Views/JobsView.vala"
	_tmp16_ = _tmp15_;
#line 151 "../src/Views/JobsView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, g_list_length (_tmp16_) > ((guint) 0));
#line 151 "../src/Views/JobsView.vala"
	(_tmp16_ == NULL) ? NULL : (_tmp16_ = (g_list_free (_tmp16_), NULL));
#line 141 "../src/Views/JobsView.vala"
	_g_object_unref0 (jobs);
#line 1117 "JobsView.c"
}

static void
printers_jobs_view_class_init (PrintersJobsViewClass * klass,
                               gpointer klass_data)
{
#line 23 "../src/Views/JobsView.vala"
	printers_jobs_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Views/JobsView.vala"
	g_type_class_adjust_private_offset (klass, &PrintersJobsView_private_offset);
#line 23 "../src/Views/JobsView.vala"
	G_OBJECT_CLASS (klass)->finalize = printers_jobs_view_finalize;
#line 1130 "JobsView.c"
}

static void
printers_jobs_view_instance_init (PrintersJobsView * self,
                                  gpointer klass)
{
#line 23 "../src/Views/JobsView.vala"
	self->priv = printers_jobs_view_get_instance_private (self);
#line 1139 "JobsView.c"
}

static void
printers_jobs_view_finalize (GObject * obj)
{
	PrintersJobsView * self;
#line 23 "../src/Views/JobsView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PRINTERS_TYPE_JOBS_VIEW, PrintersJobsView);
#line 24 "../src/Views/JobsView.vala"
	_g_object_unref0 (self->priv->printer);
#line 25 "../src/Views/JobsView.vala"
	_g_object_unref0 (self->priv->list_box);
#line 26 "../src/Views/JobsView.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 23 "../src/Views/JobsView.vala"
	G_OBJECT_CLASS (printers_jobs_view_parent_class)->finalize (obj);
#line 1156 "JobsView.c"
}

static GType
printers_jobs_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrintersJobsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) printers_jobs_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrintersJobsView), 0, (GInstanceInitFunc) printers_jobs_view_instance_init, NULL };
	GType printers_jobs_view_type_id;
	printers_jobs_view_type_id = g_type_register_static (gtk_frame_get_type (), "PrintersJobsView", &g_define_type_info, 0);
	PrintersJobsView_private_offset = g_type_add_instance_private (printers_jobs_view_type_id, sizeof (PrintersJobsViewPrivate));
	return printers_jobs_view_type_id;
}

GType
printers_jobs_view_get_type (void)
{
	static volatile gsize printers_jobs_view_type_id__once = 0;
	if (g_once_init_enter (&printers_jobs_view_type_id__once)) {
		GType printers_jobs_view_type_id;
		printers_jobs_view_type_id = printers_jobs_view_get_type_once ();
		g_once_init_leave (&printers_jobs_view_type_id__once, printers_jobs_view_type_id);
	}
	return printers_jobs_view_type_id__once;
}

